"""Helper classes for scripts for cluster support packages."""

from cyberfusion.ClusterSupport._interfaces import APIObjectInterface


class ServiceAccountEtcdCredentials(APIObjectInterface):
    """Represents object."""

    def _set_attributes_from_model(
        self,
        obj: dict,
    ) -> None:
        """Set class attributes from API output."""
        self.id = obj["id"]
        self.etcd_username = obj["etcd_username"]
        self.etcd_role_name = obj["etcd_role_name"]
        self.etcd_password = obj["etcd_password"]
        self.service_account_id = obj["service_account_id"]
        self.created_at = obj["created_at"]
        self.updated_at = obj["updated_at"]

        self.service_account = self.support.get_service_accounts(
            id_=self.service_account_id
        )[0]
